package com.syc.slm.tools.service.impl;

import com.google.gson.Gson;
import com.syc.slm.tools.service.ISyncService;
import com.syc.slm.tools.vo.DataVo;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import java.io.*;
import java.util.*;

/**
 * lin
 */
@Service
public class SyncServiceImpl implements ISyncService {

    @Value("${current.syncPath}")
    private String uploadPath;
    @Value("${current.service}")
    private String service;
    @Value("#{'${current.containsContent}'.split(',')}")
    private Set<String> containsContent;


    //# todo  啊凯补充
    @Override
    public void sync() {
        List<DataVo> dataVos = readFileList(uploadPath);
    }



    private List<DataVo> readFileList(String filepath){
        List<DataVo> datas=new ArrayList<>();
        try {
            File file = new File(filepath);
            if (!file.isDirectory()) {
                datas.addAll(readFile(file));
            } else {
                String[] filelist = file.list();
                if(filelist!=null && filelist.length>0) {
                    for (int i = 0; i < filelist.length; i++) {
                        File readfile = new File(filepath + "\\" + filelist[i]);
                        if (!readfile.isDirectory()) {
                            datas.addAll(readFile(file));
                        } else {
                            readFileList(filepath + "\\" + filelist[i]);
                        }
                    }
                }
            }

        } catch (Exception e) {
            System.out.println("readfile()   Exception:" + e.getMessage());
        }
        return datas;
    }


    private  List<DataVo> readFile( File readfile){
        List<DataVo> datas=new ArrayList<>();
        try {
            System.out.println("文件");
            System.out.println("path=" + readfile.getPath());
            System.out.println("absolutepath=" + readfile.getAbsolutePath());
            System.out.println("name=" + readfile.getName());
            BufferedReader in  = new BufferedReader(new FileReader(readfile));
            String line ;
            while ((line=in.readLine())!=null){
                if(containsContent.stream().anyMatch(line::contains) && line.contains(service)){
                    datas.add(initData(line));
                }
            }
        }catch (Exception e) {
            e.printStackTrace();
        }
        return  datas;
    }

    private DataVo initData(String data){
        DataVo vo = new DataVo();
        String time =data.substring(data.indexOf("time"),data.indexOf("database"));
        vo.setTime(time.replaceAll("time:\\[","").replaceAll("\\]","").trim());
        String database=data.substring(data.indexOf("database"),data.indexOf("measurement"));
        vo.setDatabase(database.replaceAll("database: \\[","").replaceAll("\\],","").trim());
        String measurement=(data.substring(data.indexOf("measurement"),data.indexOf("data-tags")));
        vo.setMeasurement(measurement.replaceAll("measurement: \\[","").replaceAll("\\],","").trim());

        String dataTags=(data.substring(data.indexOf("data-tags"),data.indexOf("data-fields")));
        String dataTagsTemp =dataTags.replaceAll("data-tags: \\[\\{","").replaceAll("\\}\\],","");
        String[] dataTagsArray = dataTagsTemp.split(",");
            Map<String, String> dataTagsMaps = new HashMap<>();
            Arrays.stream(dataTagsArray).forEach(x -> {
                String[] split = x.split("=");
                dataTagsMaps.put(split[0], split[1].trim());
            });
            vo.setTags(dataTagsMaps);

        String dataFields=(data.substring(data.indexOf("data-fields"),data.indexOf("Exception")));
        String dataFieldsTemp =dataFields.replaceAll("data-fields: \\[\\{","").replaceAll("\\}\\],","");
        String[] dataFieldsArray = dataFieldsTemp.split(",");
        Map<String,String> dataFieldsMaps= new HashMap<>();
            Arrays.stream(dataFieldsArray).forEach(x -> {
                String[] split = x.split("=");
                dataFieldsMaps.put(split[0], split[1].trim());
            });
            vo.setFields(dataFieldsMaps);
        System.out.println(new Gson().toJson(vo));
        return vo;
    }

}
